#include "Stdafx.h"
#include "StringCvt.h"



int GetUtf8Follow(const char* strUtf8)
{
	BYTE* u8 = (BYTE*)strUtf8;
	// modify by houzz at 19:49 2018/4/4, Ϊַ֧, ƻı
	int iFollow = 0;
	int i = 0;
	if (u8[i] < 0x80)
		iFollow = 0;
	else if (u8[i] >= 0xc0 && u8[i] < 0xe0)
		iFollow = 1;
	else if (u8[i] >= 0xe0 && u8[i] < 0xF0)
		iFollow = 2;
	else if (u8[i] >= 0xf0 && u8[i] < 0xf8)
		iFollow = 3;
	else if (u8[i] >= 0xf8 && u8[i] < 0xfc)
		iFollow = 4;
	else if (u8[i] >= 0xfc && u8[i] < 0xfe)
		iFollow = 5;
	else
	{
		return -1;
	}

	for (int j = 0; j < iFollow; j++)
	{
		if (!(u8[i + j + 1] >= 128 && u8[i + j + 1] < 192))
		{
			return -1;
		}
	}
	return iFollow;
}

int Utf8Revise(char* strUtf8)
{
	if (strUtf8 == NULL)
		return 0;

	int i;
	BYTE* u8 = (BYTE*)strUtf8;
	for (i = 0; u8[i] != 0; i++)
	{
#if 0
		if (u8[i] < 128)
		{
			continue;
		}
		else if (u8[i] >= 192 && u8[i] < 224)
		{
			if (!(u8[i + 1] >= 128 && u8[i + 1] < 192))
			{
				u8[i] = 0;
				return i;
			}
			i++;
		}
		else if (u8[i] >= 224 && u8[i] < 240)
		{
			if (!(u8[i + 1] >= 128 && u8[i + 1] < 192))
			{
				u8[i] = 0;
				return i;
			}
			if (!(u8[i + 2] >= 128 && u8[i + 2] < 192))
			{
				u8[i] = 0;
				return i;
			}

			i += 2;
		}
		else
		{
			u8[i] = 0;
			return i;
		}
#elif 0
		// modify by houzz at 19:49 2018/4/4, Ϊַ֧, ƻı
		int iFollow = 0;
		if (u8[i] < 0x80)
			iFollow = 0;
		else if (u8[i] >= 0xc0 && u8[i] < 0xe0)
			iFollow = 1;
		else if (u8[i] >= 0xe0 && u8[i] < 0xF0)
			iFollow = 2;
		else if (u8[i] >= 0xf0 && u8[i] < 0xf8)
			iFollow = 3;
		else if (u8[i] >= 0xf8 && u8[i] < 0xfc)
			iFollow = 4;
		else if (u8[i] >= 0xfc && u8[i] < 0xfe)
			iFollow = 5;
		else
		{
			u8[i] = 0;
			return i;
		}

		for (int j = 0; j < iFollow; j++)
		{
			if (!(u8[i + j + 1] >= 128 && u8[i + j + 1] < 192))
			{
				u8[i] = 0;
				return i;
			}
		}
		i += iFollow;
#else
		int iFollow = GetUtf8Follow(strUtf8 + i);
		if (iFollow < 0)
		{
			u8[i] = 0;
			return i;
		}
		i += iFollow;
#endif
	}
	return i;
}
//صֵҪͷڴ
wchar_t *ManagedStr2UnmanagedUniStr(String^ str)
{
    IntPtr p = Marshal::StringToHGlobalUni(str);
    if (p == IntPtr::Zero)
        return(NULL);

    const wchar_t *pTemp = static_cast<const wchar_t *>(p.ToPointer());
    if (pTemp == NULL) return NULL;

    size_t  len = wcslen(pTemp) + 1;
    wchar_t *pOut = new wchar_t[len];

    wcscpy_s(pOut, len, pTemp);

    Marshal::FreeHGlobal(p);
    return(pOut);
}

//йַתйܵUnicodeַ
String ^ UnmanagedStr2ManagedUniStr(wchar_t *str)
{
    return Marshal::PtrToStringUni((IntPtr)str);
}

