#pragma once
#include "OMapApi.h"
#include "StringCvt.h"
#include <Windows.h>
#include <vcclr.h>
using namespace System;
using namespace System::Collections::Generic;
using namespace System::Runtime::InteropServices;
#define MinValue(a,b) a<b?a:b
#define MaxValue(a,b) a>b?a:b
#define ARRAY_LEN 128
#define ARRAY_NUM 8
namespace OmapCLI
{
	
	public ref struct tagOApiObjGroup
	{
		DWORD idObj;
		DWORD idParent;
		int idLayer;
		int idGis;
		tagOApiObjGroup()
		{
			bAutoLoad = 1;
		}
		String^ strName;

		Int32 nChild;//һĸ
		Int32 nAllChild;	//ܸδʱֵҲһ
		BYTE bLoadOk;	//Ƿسɹ

		BYTE bSaveMerge;//ʱpChildǷϲ洢ϲ洢ɴӿʱ䣬ʹ޸ʱʱ½
		BYTE bGroup;	//Ƿϣչ
		BYTE bAutoLoad;	//ǷԶ
		BYTE iShowLevel;//Ƿ
		BYTE iShowLevelBak;//
		BYTE iShowLevelMax;//ʾ
		//BYTE bCrypt;	//Ƿ, ˼ԶؽԶʧЧ
		BYTE bShare;	//Ƿ01ֻ2д 
		BYTE bReadOnly;	//Ƿֻ, 0: , 1: , 2: 
		BYTE bNotHotId;	//ǷӦ¼
		BYTE bRelate;	//ǷǹĿǰڱǩ켣
		DWORD dwBind;	//Ƿ󶨵ǰ豸>0ΪֵΪǩ 
		DWORD dwBindCheck;	//豸ʱ֤0Ϊɽ>0 

		BYTE bLink;		//Ƿӵûļ 
		BYTE bLinkAutoCheck;	//ǷԶǷи 
		String^ strLink;

		DWORD biChildiOverlay;//λʾЩŲΣֵղؼз䶯ʱԶˢ
		//cli::array<BYTE>^ pwd;//õ
	};
	//ʾǩĽṹ
	public ref struct tagOApiMapSign{
		DWORD idObj;
		DWORD idParent;
		int idLayer;
		int idGis;
		tagOApiMapSign()
		{
			ei = gcnew tagMapSignExtInfo();
			mse = gcnew tagMapSignEvent();
			pic = gcnew tagSignPic();
		}
		String^ strName;
		String^ pstrComment;
		double lat;
		double lng;
		BYTE bRealLl;	//0:gcj02γ, 1:ʵγ, 2:ǰϵµƽ
		int iAltitude;	//
		unsigned long iTime;		//ʱ

		BYTE bEditMode;//Ƿɱ༭
		BYTE iOverlayIdx;//Ų㼶
		//5λΪ𣬵3λΪλãֱ0Ϊλã1£2ϣ3ϣ4ϣ5£>6ʾ
		BYTE iTxtShowSta;
		//λ0ΪĬϣԶλã1-6ֱӦiTxtShowSta0-5
		BYTE iTxtShowStaSet;
		ref struct tagSignPic {
			//ǩͼ־0ΪĬж룬1Ϊж
			BYTE iSignAlignFlag;
			//ڱǩϵ0, 1-99, 100-125(A-Z), 126-151(a-z)
			BYTE iSignPicNum;
			BYTE iPicScale;	//0:defalut,>=1 32*iPicScale/10

			int iSignPic;	//0:no picture,>=1 has sign picture
			DWORD dwSignClr;

			//0:default, 1-63ƣ65-127 
			BYTE iSignPicNumOffx;
			BYTE iSignPicNumOffy;
			//8ɫ0(default)1ڣ2ף3죬4̣56ƣ78
			BYTE iSignPicNumClr;
			//0:default,1-8(Ӵ1-16أ65-80(1-16أ
			BYTE iSignPicNumSize;
		};
		tagSignPic ^pic;
		BYTE iTxtType;	//0:not show txt,1:show txt ,2:show text with border, 3: custom txt
		BYTE iShowLevel;
		BYTE iShowLevelBak;	//ʾʱָiShowLevelֵ
		BYTE iShowLevelMax;	//show between iShowLevel-iShowLevelMax
		BYTE bTimeUncertain;	//iTimeʱǷ
		//ԶϢ
		ref struct tagMapSignExtInfo {
			tagMapSignExtInfo()
			{
				idExtBak = gcnew cli::array<INT64>(MAX_API_ID_BAK_CNT);
			}
			String^ strFontName;//100
			BYTE bShowComment;
			BYTE bCommentAlign;
			BYTE bFontZoomWithMap;
			BYTE bFontWithBox;
			BYTE iFontAlpha;
			BYTE bFontEffect;
			BYTE bFontBkStyle;
			BYTE nFontBindLevel;
			BYTE nFontMinLevel;
			BYTE nFontMaxLevel;
			int iFontSize;
			DWORD dwFontClr;
			DWORD dwFontBkClr;
			float fFontRotateAngle;
			BYTE bNoHotFontEvent;


			INT64 idExt;
			cli::array<INT64>^ idExtBak;//MAX_API_ID_BAK_CNT;
			BYTE bExtEditable;
			int nExtDataLen;
			String^ strExtTypeName;//10	// ʾͼ

			//ΪͼƬָʾǷʾڵͼԼʾļ𼰳
			BYTE bExtMapShow;
			BYTE bExtMapThumb;
			BYTE bExtMapZoom;
			BYTE nExtMapBindLevel;
			BYTE nExtMapMinLevel;
			BYTE nExtMapMaxLevel;
			BYTE nExtMapAlpha;

			//fMapRotateAngle==-1000ʱQUADʾͼΣmaplt,maprt,maplb,maprbֱĵ꣬XYŵint
			//ĿǰûQUADԺҪʱ
			float fMapRotateAngle;

			BYTE bNoHotMapEvent;
			int nExtMapWidth;
			int nExtMapHeight;
			float fXScale;
			float fYScale;
		};
		tagMapSignExtInfo ^ei;
		ref struct tagMapSignEvent {
			DWORD nRadius;
			DWORD dwShowClr;
		};
		tagMapSignEvent ^mse;
	};
	//켣ϵĵϢ
	public ref struct tagOApiMapTrackPoint{
		tagOApiMapTrackPoint()
		{
			clw = gcnew tagCadLwpLineWidth();
		}
		tagOApiMapTrackPoint(double dLng,double dLat,int iAlt)
		{
			clw = gcnew tagCadLwpLineWidth();
			lat = dLat;
			lng = dLng;
			iAltitude = iAlt;
		}
		double lat;
		double lng;
		int time;//켣ʱ
		int iAltitude;		// iAltitude >> 16 == 1 ʾõΪͼ(ӹ켣)ʼ㼴ǰһ

		//չʽCAD
		double dCadBulge;
		int iCadRet;
		
		ref struct tagCadLwpLineWidth{
			float fWidStart;
			float fWidEnd;
		};
		tagCadLwpLineWidth^ clw;
	};

	//ʾ켣Ľṹ
	public ref struct tagOApiMapTrack{
		DWORD idObj;
		DWORD idParent;
		int idLayer;
		int idGis;
		tagOApiMapTrack()
		{
			mtd = gcnew tagOApiMapTrackDraw();
			mtd->iLineAlpha = 50;
			mtd->iLineWidth = 3;
			mtd->dwLineClr = RGB(0, 0, 255);
			//pMtp = gcnew cli::array<tagOApiMapTrackPoint ^>(10);
		}
		String^ strName;
		String^ pstrComment;
		


		BYTE iTrackType;	// 켣: Լ, ɽ ...
		BYTE iOverlayIdx;	//Ų㼶
		BYTE bRealLl;	//tagOApiMapTrackPointV1еľγǷʵγ

		BYTE iShowLevel;//ʾ
		BYTE iShowLevelBak;
		BYTE iShowLevelMax;//show between iShowLevel-iShowLevelMax
		BYTE bShowName;//Ƿʾ켣
		BYTE bEdit;//켣Ƿɱ༭
		DWORD dwAltitudeColor;
		//Զֶڱ켣Զ
		BYTE iCustomType1;
		BYTE iCustomType2;
		BYTE iCustomType3;
		BYTE iCustomType4;
		int dwCustom1;
		int dwCustom2;
		cli::array<tagOApiMapTrackPoint^>^ pMtp;
		int nMtp;//켣
		//켣Ƶ
		ref struct tagOApiMapTrackDraw{
			DWORD dwLineClr;	//ɫ
			DWORD dwCircleClr;
			int iLineWidth;		//߿
			BYTE iCircleWidth;
			BYTE iLineAlpha;	//͸
			BYTE iShowType;		// 켣: ʾȨ, CAD ...
			BYTE iLineType;		//
			//BYTE bNeedDrawDetail;	//ǷҪƽǶȡʾϢ
			BYTE bClose;			//Ƿպ
		};
		tagOApiMapTrackDraw^ mtd;
	};
	//ʾͼεĽṹ
	public ref struct tagOApiMapShape{
		DWORD idObj;
		DWORD idParent;
		int idLayer;
		int idGis;
		tagOApiMapShape()
		{
			iLineAlpha = 50;
			iAreaAlpha = 50;
			iLineWidth = 1;
			dwLineClr = RGB(0, 0, 255);
			dwAreaClr = RGB(0, 0, 255);
		}
		cli::array<tagOApiMapTrackPoint^>^ pMtp;
		int nMtp;//ͼεĽڵ
		String^ strName;
		String^ pstrComment;
		//iShowFlag:0 ʾԣ1 ʾ 2 ʾ 3 ʾ
		BYTE iShowFlag;
		BYTE iOverlayIdx;
		BYTE bRealLl;
		double dStartAngle;	//ͼΪʱͨʼǶֹǶȱʾԲΡ
		double dEndAngle;
		
		BYTE iLineWidth;	//߿
		BYTE iLineAlpha;	//͸
		BYTE iLineType;
		BYTE iAreaAlpha;	//͸
		BYTE bEditMode;		//Ƿɱ༭
		BYTE iShowLevel;
		BYTE iShowLevelBak;
		BYTE iShowLevelMax;
		//0:Ĭɫ䣬1ɫ䣬2ͼ䣬3CADͼ
		int iFillType;
		//ɫʱ0ҽ䣬1м佥ٵһԭ2ΧĽ, CADͼʱΪǷͼ
		int iFillSubType;
		//ⲿRgn0Ϊȫⲿ>0Ϊǰٸⲿڲڴο
		WORD iOuterRgnIdx;
		//change by houyb at 2018/03/27
		//BYTE iOuterRgnIdx;
		DWORD dwLineClr;	//ɫ
		DWORD dwAreaClr;	//ɫ

		
		//ͼID
		DWORD dwFillPattern;
		// ɫ2, 䱳ɫ
		DWORD dwFillChgClr;
		float fFillRotate;
		//CADͼ
		float fFillScale;

		// 洢ľֵ
		float fFillOffsetX;
		float fFillOffsetY;
	};
	public ref struct tagOApiLatLng{
		tagOApiLatLng()
		{
			lat = 0;
			lng = 0;
		}
		double lat;
		double lng;
	};
	//ʾһĽṹ
	public ref struct tagOApiMapDirectionsUnit{
		String^ strTitle;//
		cli::array<String^>^ strSubTitle;//Ӳ
		int nSubCount;	//Ӳ
		short iType;	//ͨ
		int nLl;		//llList
		cli::array<tagOApiLatLng^>^ llList;
	};
	//ʾ·ߵĽṹ
	public ref struct tagOApiMapDirections{
		DWORD idObj;
		DWORD idParent;
		int idLayer;
		int idGis;
		tagOApiMapDirections()
		{
			dirSrh = gcnew tagMapDirectionsSrh();
			dwLineClr = RGB(255, 0, 0);
			iLineWidth = 7;
			iLineAlpha = 60;
		}
		String^ strName;
		String^ pstrComment;
		cli::array<tagOApiMapDirectionsUnit^>^ punit;
		int nUnit;//
		String^ strTitle;
		String^ strDirStart;
		String^ strDirEnd;
		//ĵ
		ref struct tagMapDirectionsSrh{
			tagMapDirectionsSrh()
			{
				mpStart = gcnew tagOApiLatLng();
				mpEnd = gcnew tagOApiLatLng();
				mpVia = gcnew cli::array<tagOApiLatLng ^>(MAX_API_DIR_WAYPOINTS);
				iDirMode = 0;
			}
			tagOApiLatLng^ mpStart;//ľγ
			tagOApiLatLng^ mpEnd;//յľγ
			cli::array<tagOApiLatLng^>^ mpVia;//м䵼ľγ
			int iDirMode;
		};
		tagMapDirectionsSrh^ dirSrh;
		BYTE bEdit;//Ƿɱ༭

		BYTE iLineWidth;	//߿
		BYTE iLineAlpha;	//͸
		DWORD dwLineClr;	//ɫ

		String^ strGroup;
		BYTE iExportFlag;
		BYTE iOverlayIdx;	//Ų㼶
		BYTE bRealLl;		//Ƿʵγ

		BYTE iShowLevel;	//ʾ
		BYTE iShowLevelBak;
		BYTE iShowLevelMax;//show between iShowLevel-iShowLevelMax
	};
	public ref struct tagOApiObjIdItem
	{
		int iDataLen;	// ݵĳ
		int iObjType;
		DWORD idObj;
		DWORD idParent;
		int idLayer;
		int idGis;
		//INT64 iCustomData;	// ӿڿԶ
	};
	// 
	public ref struct tagOApiObjectSrhReqCli{
		int iReqVer;	// 汾, ĿǰΪ0

		int iSrhOpt;	// նSRH_OBJ_OPT_XXX
		int iObjType;	// 0ʾκ

		DWORD idParent;	// 0ʾղؼ
		DWORD idShapeSelect;	// 0ʾͼ
		BYTE bNoChild;		// 0ʾļ, 1ʾֻidParentһ
		int iMaxCnt;		// 0ʾ

		String^ strSrhTxt;
		int iSrhValue;

		BYTE bNoCase;
	};
	// Ӧ
	public ref struct tagOApiObjectSrhResCli{
		DWORD idObj;	//id
		int iObjType;	//
	};
	public ref struct tagOApiRelatePoint{
		double lng;
		double lat;
		BYTE bReal;
		double x;
		double y;
	};
	public ref struct tagOmapLatlngCli{
		double lat;
		double lng;
		BYTE bReal;//Ƿʵγ
	};
	public ref struct tagOphotoMapPicCli
	{
		INT64 idPic;//Ƭid
		unsigned int tmPhoto;//Ƭʱ
		double lat;//ά
		double lng;//
		int iAction;//ACTION_MOUSE_MOVE 1  ACTION_MOUSE_CLICK 2
		int iTmp;//, OMAP_WIN_CMD_TIME_TO_LATLNGñƬʱ켣ʱĲֵ
	};
	public ref struct tagOmapGeoDecodeCli{
		tagOmapGeoDecodeCli()
		{
			//oll = gcnew tagOmapLatlngCli();
			strArea = gcnew cli::array<String ^>(ARRAY_NUM);
		}
		tagOmapLatlngCli^ oll;
		int nLevel;//ͼĲ㼶   ʡ3ʡ32
		cli::array<String^>^ strArea;
	};
	public ref struct tagOApiItemList{
		DWORD idObj;//id
		int iType;//
		String^ strName;//
	};
	public ref struct tagOApiObjChageHdrCli{
		int iVer;
		int iFlag;	// 0: ޸, 1: ɾ
		int nList;
		cli::array<DWORD>^ pdwList;
	};
	public ref struct tagWinMapInfoCli{
		double lng;
		double lat;
		BYTE bReal;

		double x_lng;
		double y_lat;
		BYTE bReal2;

		int iMapLevel;
		int iMapType;

		//// άǰʹ
		//int iMapX;
		//int iMapY;
		//int iRet;
	};
	public ref struct tagOApiPixelInfoCli{
		double dMeterX;
		double dMeterY;
		int iLevel;
	};
	public ref struct tagOApiSysCoorInfoCli{
		int iCoorType;
		cli::array<byte>^ hash;	// Ч, жǷ˱仯, [0, άƽ, 4: īʱ]
		int nInfoLen;
		String^ strInfo;
	};
	public ref struct tagOApiShapeFillCadPatUnitCli{
		double dAngle;
		double dxOrg;
		double dyOrg;
		double dxDelta;
		double dyDelta;
		int nDash;
		cli::array<double>^ dDashList;
	};

	public ref struct tagOApiShapeFillCadPatItemCli{
		String^ strName;
		String^ strComment;

		double dDefaultScale;
		DWORD id;
		cli::array<tagOApiShapeFillCadPatUnitCli^>^ pSfcpu;
	};
	public ref struct tagOApiObjTree
	{
		int iObjType;
		tagOApiMapSign^ pSign;
		tagOApiMapTrack^ pTrack;
		tagOApiMapShape^ pShape;
		tagOApiMapDirections^ pDir;
		tagOApiObjGroup^ pGroup;
		tagOApiObjTree^ pNext;
		tagOApiObjTree^ pChild;
	};
	public ref struct tagOApiTreeMgr
	{
		tagOApiObjTree^ treeNode;
		int nChild;
		tagOApiTreeMgr^ pNext;
		tagOApiTreeMgr^ pFront;
	};
	public ref struct tagOmapGetMapCli{
		double x_lng1;
		double y_lat1;
		double x_lng2;
		double y_lat2;
		BYTE bRealLl;

		INT64 iMaxPixel;
		int iMaxLevel;

		DWORD width;
		DWORD height;
		cli::array<byte>^ pData;
	};
	public ref struct tagOmapGetMapFileCli{

		INT64 idMap;	// ı, ʱͬµĻ滻ɵ
		INT64 iValue;	// Ҫ̶

		int iFlag;		// 1ʾͼȫʱֱӺ
		int iRet;		//  ֵ

		String^ strFile;	// ļΪʱдʧʱͨpData
		bool bFile;			// д״̬

		cli::array<byte>^ pData;

		double x_lng1;
		double y_lat1;
		double x_lng2;
		double y_lat2;
		BYTE bRealLl;	// 

		int iMapLevel;
		int iMapType;
		DWORD width;
		DWORD height;
		int iTotalPic;
		int iHasPic;
		int iPostCnt;	// ȡͼÿȡŷһg_msgGetMapProcessϢ(WPARAM=iTotal, PARAM=iDeal);
		int iTmp;	// άʹõʱ
		BYTE bSendReq;	// 1ʾͼڻ߲ȫʱ
		BYTE bImageType;	// GET_MAP_FILE_IMG_TYPE_XXX
	};
	public ref struct tagOmapReqContourCli{

		INT64 idMap;	// ı, ʱͬµĻ滻ɵ
		INT64 iValue;	// Ҫ̶

		double x_lng1;
		double y_lat1;
		double x_lng2;
		double y_lat2;
		BYTE bRealLl;
		int iMapLevel;	// 󼶱
		int iElevValue;	// ȸ߼

		int iCheckFlag;	// 0: ʾֱȡ, 1: ʾֻΪ
		int iCheckResult;

		int iRet;		// ֵ
		int iNeedVip;	// ҪVIP
		BYTE bPart;
		int iPostCnt;	// ȡȸ߹ÿȡٴμһg_msgGetContourProcessϢ(WPARAM=iTotal, PARAM=iDeal);
	};
	public ref struct tagConBox
	{
		double x_lng1;
		double x_lng2;
		double y_lat1;
		double y_lat2;
		INT64 idMap;
		int iElevValue;
		int iMapLevel;
		int iPostCnt;
		INT64 iValue;
	};
	public ref struct tagSysMsg
	{
		tagSysMsg()
		{
			iVip = 0;
			//iOmapVer = 0;
			bSetBtn = false;
			bFollowWin = false;
			bFollowObj = false;
			dxCoorCenter = 0;
			dyCoorCenter = 0;
			dxPixel = nullptr;
			dyPixel = nullptr;
			iCoorType = 0;
			hashCoor = nullptr;
			ptagWinInfo = nullptr;
		}
		int iVip;
		//int iOmapVer;
		bool bSetBtn;
		bool bFollowWin;
		bool bFollowObj;
		cli::array<double>^ dxPixel;
		cli::array<double>^dyPixel;
		double dxCoorCenter;
		double dyCoorCenter;
		int iCoorType;
		cli::array<char>^ hashCoor;
		tagWinMapInfoCli^ ptagWinInfo;
	};
	public ref struct tagWebSocketConf {
		int iWssFlag;
		// int iWssUserLimitFlag;
		DWORD dwWssUserLimitIP;
		DWORD wPort;
		String^ strPsk;
		String^ strSslCaFn;
		String^ strSslCertFn;
		String^ strSslKeyFn;

		int bHttpTileService;
	};
	public ref struct tagPrj
	{
		int iVersion;
		String^ strPrjType;//GEOGCSͷϵPROJCSͷͶӰϵ
		String^ strPrjName;
		//ϵ Ҳл׼
		String^ strGeogcs;//г32ֽ
		//ػ׼
		String^ strDatum;
		//嶨
		String^ strSpheroid;
		double dSemimajorAxis;//볤
		double dSemiminorAxis;//
		double dInverseFlattening;//
		//
		String^ strPrimem;
		double dPrimeMeridian;
		//ǵλ
		String^ strAngularUnit;
		double dAngularUnit;//ǵλ ÿλ
		//ߵλ
		String^ strLinearUnit;
		double dLinearUnit;//ߵλ
		//ͶӰ ͶӰϵ
		String^ strProjection;
		//
		double dFalseEasting;//ƫ
		double dFalseNorthing;//ƫ
		double dCentralMeridian;//뾭
		double dScaleFactor;//
		double dLatitudeOfOrigin;//Զ
		//gisϵͳûп
		double dLatitudeOfCenter;
		double dStandardParallel_1;
		double dStandardParallel_2;
		double dLatitude_Of_1st_Point;
		double dLatitude_Of_2nd_Point;
		double dLongitude_Of_1st_Point;
		double dLongitude_Of_2nd_Point;
		double dAzimuth;
		double dLongitudeOfCenter;
		int iPrjType;
		int iCoordType;
	};

	public ref struct tagCustomMap {
		int idMap;
		int idLayerBig;
		int idLayerSmall;
		DWORD iLayerBigFlag;
		DWORD iLayerSmallFlag;
		int iMinLevel;
		int iMaxLevel;
		int iCoordType;
		int iTileFormat;
		int iTileSize;
		DWORD iVersion;
		BYTE bUseLayer;
		BYTE bIsSatellite;
		String^ strName;
		String^ strHost;
		WORD wPort;
		BYTE iHostStart;
		BYTE iHostEnd;
		String^ strUrl;
	};

	public ref struct tagPluginVer
	{
		int iOmapVer;
		int iCadPluginVer;
		int iGisPluginVer;
	};

	public ref struct tagCusMainBtnCli {
		int nId; // 1~MAX_CUS_MAIN_BTN
		String ^strTxt;	// ťʾϢ

		int iResult;	// ѯʱѯ, -1: idΧ, 0: , 1: 

		int nPngLen;
	
		double dAlign;
		void *pPngData;	// ݸڱṹĺ
	
	};

	public ref struct tagCusFavMenuCli {
		int nId;	// 1~MAX_CUS_FAV_MENU
		String ^strTxt;	// ˵

		int iResult;	// ѯʱѯ, -1: idΧ, 0: , 1: 
		int nList;		// ˵ʱ, IDб

		cli::array<int^>^ pIdList; // ݸڱṹĺ

	};

	public ref struct tagCusMainMenuCli {
		int nId; // 1~MAX_CUS_MAIN_MENU: ʾЧĲ˵, <0ʾΪӲ˵
		String ^strTxt;	// ˵ť

	};

	public ref struct tagMapShapeDetail {
		DWORD idObj;	// IDΪ0ʾûҵӦ
		int iPointCnt;	// 
		int iAreaCnt;	// 
		double dPerimeter;	// ܳ
		double dAreaSize;	// 
	};

	public ref struct tagMapTrackDetail{
		DWORD idObj;	// IDΪ0ʾûҵӦ
		int tStart;
		int tEnd;
		int iTotalPoint;
		int iTotalDist;	// 
		int iAgvSpeed;	// ǧÿСʱ
		int iMaxSpeed;
		int iMinAltitude;
		int iMaxAltitude;
	};

	public ref struct tagPOINTCli
	{
		LONG  x;
		LONG  y;
	};

	public ref struct tagSIZECli
	{
		LONG        cx;
		LONG        cy;
	};

	public ref struct tagRECTCli
	{
		LONG    left;
		LONG    top;
		LONG    right;
		LONG    bottom;
	};

	public ref struct tagOmapWndRect {
		int iVersion;

		tagRECTCli^ rectMapOfWnd;	// ͼӴ, ڳڵλ

	};

	public ref struct tagMapObjEvent {
		int iVersion;
		DWORD idObj;

		tagRECTCli^ rectMapOfWnd;	// ͼӴ, ڳڵλ
		tagPOINTCli^ ptClickOfMap;	// ¼ڵͼӴڵλ

	};

	public ref struct tagMapObjShowWnd {
		int iVersion;
		tagPOINTCli^ ptMapWnd;	// ͷָλ
		tagSIZECli^ sizeObjWnd;		// ҪʾĴڴС

		DWORD idObj;		// ҪʾĶID[Ϊ0ʾ󷽵Ĺť]

		BYTE bCloseType;		// رձ־, 0: Ĭ, 1:  رհťܹر
		BYTE bCloseEvent;		// ر¼, 0: , 1: [OMAP_API_CMD_OBJ_CLOSE_WND_EVENT, tagOApiRevHdr+DWORD]

		int nHtml;
		
		String ^pHtml;		// ҳʽʾ
		
	};

	public ref struct tagCusShowWnd
	{
		int iVersion;

		int idWnd;//idWndΧ1-10֮
		tagRECTCli^ rectWnd;		// ҪʾĴڴС
		String^ strDlgTitle;//ı
		BYTE bCloseEvent;		// ر¼, 0: , 1: [OMAP_API_CMD_CUS_WND_CLOSE_EVENT, tagOApiRevHdr+DWORD]

		int nHtml;
		
		String^ pHtml;		// ҳʽʾ
		
	};

	[Serializable]
	[FlagsAttribute]
	public enum class eEventHanderType
	{
		eBringWindowsToTop,
		eOmapBtnCliked,
		eGetMapProcess,
		eGetContourProcess,
		eGetMapFile,
		eDecodeObjTree,
		//eGetSysCoordProj,
		eTest,
		eObjCloseWndEvent,
		eGetCmdCusCloseWnd,
	};
	public delegate void GetLatlngEventHander(tagOmapLatlngCli^ oll);
	public delegate void GetGeoDecodeEventHander(tagOmapGeoDecodeCli^ gd);
	public delegate void GetLatlngByTimeEventHander(cli::array<tagOphotoMapPicCli^>^ pPics);
	public delegate void GetObjListEventHander(cli::array<tagOApiItemList^>^ pOlvs);
	public delegate void GetObjSignEventHander(tagOApiMapSign^ pSign);
	public delegate void GetObjTrackEventHander(tagOApiMapTrack^ pTrack);
	public delegate void GetObjShapeEventHander(tagOApiMapShape^ pShape);
	public delegate void GetObjDirectionsEventHander(tagOApiMapDirections^ pDir);
	public delegate void GetObjGroupEventHander(tagOApiObjGroup^ pGroup);
	public delegate void GetObjSignArrayEventHander(cli::array<tagOApiMapSign^>^ pSigns);
	public delegate void GetObjTrackArrayEventHander(cli::array<tagOApiMapTrack^>^ pTracks);
	public delegate void GetObjShapeArrayEventHander(cli::array<tagOApiMapShape^>^ pShapes);
	public delegate void GetObjDirectionsArrayEventHander(cli::array<tagOApiMapDirections^>^ pDirs);
	public delegate void GetObjGroupArrayEventHander(cli::array<tagOApiObjGroup^>^ pGroups);
	public delegate void NullParamEventHander(eEventHanderType eType);
	public delegate void GetObjChangeEventHander(tagOApiObjChageHdrCli^ pOch);
	public delegate void GetMapInfoEventHander(tagWinMapInfoCli^ pWmi);
	public delegate void GetGooglePixelInfoEventHander(cli::array<tagOApiPixelInfoCli^>^ pOpi);
	public delegate void GetSysCoorCenterEventHander(tagOApiRelatePoint^ pOrp);
	public delegate void GetSysCoorInfoEventHander(tagOApiSysCoorInfoCli^ pSci);
	public delegate void GetObjTreeStructEventHander(tagOApiObjTree^ pObjTree);
	public delegate void GetProgressRateEventHander(double dProgRate, eEventHanderType eType);
	public delegate void GetObjSrhResEventHander(cli::array<tagOApiObjectSrhResCli^>^ pSrhRes);
	public delegate void GetOmapMapDataEventHander(tagOmapGetMapCli ^pMap);
	public delegate void GetOmapMapFileEventHander(tagOmapGetMapFileCli^ pMapFile);
	public delegate void GetContourEventHander(tagOmapReqContourCli^ pReqCon);
	public delegate void SetObjTreeEventHander(cli::array<tagOApiObjIdItem^>^ pObjIds);
	public delegate void SetOmapBtnEventHander(int iBtnStatus);
	public delegate void GetWebSocketConfEventHander(tagWebSocketConf^ pWebSocket);
	public delegate void GetCustomMapEventHander(cli::array<tagCustomMap^>^ pCms);
	//public delegate void SetSysCoordProj();
	public delegate void GetSysCoordProjEventHander(tagPrj^ pPrj);
	public delegate void GetOmapPluginVerEventHander(tagPluginVer^ pPluginVer);
	public delegate void GetOmapWndRectEventHander(tagOmapWndRect^ pOmapWndRect);
	public delegate void GetMapShapeDetailEventHander(tagMapShapeDetail^ pMapShapeDetail);
	public delegate void GetMapTrackDetailEventHander(tagMapTrackDetail^ pMapTrackDetail);
	public delegate void GetCusMainBtnEventHander(cli::array < tagCusMainBtnCli^>^ pCbs,int nCmdId);
	public delegate void GetCusFavMenuEventHander(cli::array < tagCusFavMenuCli^>^ pCfs, int nCmdId);
	public delegate void GetObjEventHander(int iObjEventCmd,int nCmdId);
	public delegate void GetCusMainMenuClickEventHander(tagCusMainMenuCli^ pCmm);
	public delegate void GetObjEventTirggerEventHander(tagMapObjEvent^ pMoe);
	public delegate void GetObjCloseWndEventHander(int idObj, eEventHanderType eType);
	public ref class COmapApiCLI
	{
	private:
		GetGeoDecodeEventHander^ m_ehGeoDecode;
		GetLatlngEventHander^ m_ehGetLatlng;
		GetLatlngByTimeEventHander^ m_ehGetLatlngByTime;
		GetObjListEventHander^ m_ehGetObjList;
		GetObjSignEventHander^ m_ehGetSign;
		GetObjTrackEventHander^ m_ehGetTrack;
		GetObjShapeEventHander^ m_ehGetShape;
		GetObjDirectionsEventHander^ m_ehGetDir;
		GetObjGroupEventHander^ m_ehGetGroup;
		GetObjSignArrayEventHander^ m_ehGetSigns;
		GetObjTrackArrayEventHander^ m_ehGetTracks;
		GetObjShapeArrayEventHander^ m_ehGetShapes;
		GetObjDirectionsArrayEventHander^ m_ehGetDirs;
		GetObjGroupArrayEventHander^ m_ehGetGroups;
		NullParamEventHander^ m_ehNullParam;
		GetObjChangeEventHander^ m_ehObjChange;
		GetMapInfoEventHander^ m_ehMapInfo;
		GetGooglePixelInfoEventHander^ m_ehPixelInfo;
		GetSysCoorCenterEventHander^ m_ehSysCoorCenter;
		GetSysCoorInfoEventHander^ m_ehSysCoorInfo;
		GetObjTreeStructEventHander^ m_ehGetObjTree;
		GetProgressRateEventHander^ m_ehGetProgRate;
		GetObjSrhResEventHander^ m_ehGetObjSrhRes;
		GetOmapMapDataEventHander^ m_ehGetOmapMapdata;
		GetOmapMapFileEventHander^ m_ehGetMapFile;
		GetContourEventHander^ m_ehGetContour;
		SetObjTreeEventHander^ m_ehSetObjTree;
		SetOmapBtnEventHander^ m_ehSetOmapBtn;
		GetWebSocketConfEventHander^ m_ehGetWebSocketConf; 
		GetCustomMapEventHander^ m_ehGetCusMap;
		//SetSysCoordProj^ m_ehSetSysCoordProj;
		GetSysCoordProjEventHander^ m_ehGetSysCoordProj;
		GetOmapPluginVerEventHander^ m_ehGetPluginVer;
		GetOmapWndRectEventHander ^ m_ehGetOmapWndRect;
		GetMapShapeDetailEventHander^ m_ehGetMapShapeDetail;
		GetMapTrackDetailEventHander^ m_ehGetMapTrackDetail;
		GetCusMainBtnEventHander^ m_ehGetMainBtn;
		GetCusFavMenuEventHander^ m_ehGetFavMenu;
		GetObjEventHander^ m_ehGetObjEvent;
		GetCusMainMenuClickEventHander^ m_ehGetCusMainMenuClickEvent;
		GetObjEventTirggerEventHander^ m_ehGetObjEventTirgger;
		GetObjCloseWndEventHander^ m_ehGetCloseWnd;
		tagConBox^ m_tagConBox;
		tagOApiShapeFillCadPatHdr *m_pFillCadPatHdr;
		//Ƿ1:(Чʸߣռڴ)0ÿһһEventHander 2 : νṹ
		BYTE m_bBatchGetObjTree;
		tagOApiMemBuf * m_ptagBuf;
		DWORD m_idParent;

	protected:
		int SetOmapSelObjectTree(int iCmd, tagOApiMemBuf tag, bool bFreeBuf);
		bool AddObjTreeToBuf(tagOApiMemBuf * ptagBuf, tagOApiObjTree^ pObjTree, DWORD idParent);
		bool AppendObjToBuf(tagOApiMemBuf * pBuf, tagOApiObjTree^ pObjTree, int &iItemCur);
		int  SendMessageToOmap(int iCmdId, void *pData, int nData, INT64 *plResult);
	public:
		COmapApiCLI()
		{
			m_tagConBox = gcnew tagConBox();
			m_tagSysMsg = gcnew tagSysMsg();
			m_ptagBuf = NULL;
			m_pFillCadPatHdr = nullptr;
			m_ehGeoDecode = nullptr;
			m_ehGetLatlngByTime = nullptr;
			m_ehGetObjList = nullptr;
			m_ehGetSign = nullptr;
			m_ehGetTrack = nullptr;
			m_ehGetShape = nullptr;
			m_ehGetDir = nullptr;
			m_ehGetGroup = nullptr;
			m_ehMapInfo = nullptr;
			m_ehPixelInfo = nullptr;
			m_ehSysCoorCenter = nullptr;
			m_ehSysCoorInfo = nullptr;
			m_ehGetObjTree = nullptr;
			m_ehGetProgRate = nullptr;
			m_ehGetObjSrhRes = nullptr;
			m_ehGetOmapMapdata = nullptr;
			m_ehGetMapFile = nullptr;
			m_ehGetContour = nullptr;
			m_ehSetOmapBtn = nullptr;
			m_ehGetWebSocketConf = nullptr;
			m_ehGetCusMap = nullptr;
			//m_ehSetSysCoordProj = nullptr;
			m_ehGetSysCoordProj = nullptr;
			m_ehGetPluginVer = nullptr;
			m_ehGetOmapWndRect = nullptr;
			m_ehGetMapShapeDetail = nullptr;
			m_ehGetMapTrackDetail = nullptr;
			m_ehGetMainBtn = nullptr;
			m_ehGetFavMenu = nullptr;
			m_ehGetObjEvent = nullptr;
			m_ehGetCusMainMenuClickEvent = nullptr;
			m_ehGetObjEventTirgger = nullptr;
			m_ehGetCloseWnd = nullptr;
		}
		tagSysMsg^ m_tagSysMsg;
#pragma region EventHander
		void WndCmd(tagOmapLatlngCli^ obj)
		{
			if (m_ehGetLatlng&&obj)
			{
				m_ehGetLatlng(obj);
			}
		}
		void WndCmd(tagOmapGeoDecodeCli^ obj)
		{
			if (m_ehGeoDecode&&obj)
			{
				m_ehGeoDecode(obj);
			}
		}
		void WndCmd(cli::array<tagOphotoMapPicCli^>^ obj)
		{
			if (m_ehGeoDecode&&obj)
			{
				m_ehGetLatlngByTime(obj);
			}
		}
		void WndCmd(cli::array<tagOApiItemList^>^ obj)
		{
			if (m_ehGetObjList&&obj)
			{
				m_ehGetObjList(obj);
			}
		}
		void WndCmd(tagOApiMapSign^ obj)
		{
			if (m_ehGetSign&&obj)
			{
				m_ehGetSign(obj);
			}
		}
		void WndCmd(tagOApiMapTrack^ obj)
		{
			if (m_ehGetTrack&&obj)
			{
				m_ehGetTrack(obj);
			}
		}
		void WndCmd(tagOApiMapShape^ obj)
		{
			if (m_ehGetShape&&obj)
			{
				m_ehGetShape(obj);
			}
		}
		void WndCmd(tagOApiMapDirections^ obj)
		{
			if (m_ehGetDir&&obj)
			{
				m_ehGetDir(obj);
			}
		}
		void WndCmd(tagOApiObjGroup^ obj)
		{
			if (m_ehGetGroup&&obj)
			{
				m_ehGetGroup(obj);
			}
		}
		void WndCmd(cli::array<tagOApiMapSign^>^ obj)
		{
			if (m_ehGetSigns&&obj)
			{
				m_ehGetSigns(obj);
			}
		}
		void WndCmd(cli::array<tagOApiMapTrack^>^ obj)
		{
			if (m_ehGetTracks&&obj)
			{
				m_ehGetTracks(obj);
			}
		}
		void WndCmd(cli::array<tagOApiMapShape^>^ obj)
		{
			if (m_ehGetShapes&&obj)
			{
				m_ehGetShapes(obj);
			}
		}
		void WndCmd(cli::array<tagOApiMapDirections^>^ obj)
		{
			if (m_ehGetDirs&&obj)
			{
				m_ehGetDirs(obj);
			}
		}
		void WndCmd(cli::array<tagOApiObjGroup^>^ obj)
		{
			if (m_ehGetGroups&&obj)
			{
				m_ehGetGroups(obj);
			}
		}
		void WndCmd(eEventHanderType obj)
		{
			if (m_ehNullParam)
			{
				m_ehNullParam(obj);
			}
		}
		void WndCmd(tagOApiObjChageHdrCli^ obj)
		{
			if (m_ehObjChange)
			{
				m_ehObjChange(obj);
			}
		}
		void WndCmd(tagWinMapInfoCli^ obj)
		{
			if (m_ehMapInfo)
			{
				m_ehMapInfo(obj);
			}
		}
		void WndCmd(cli::array<tagOApiPixelInfoCli^>^ obj)
		{
			if (m_ehPixelInfo)
			{
				m_ehPixelInfo(obj);
			}
		}
		void WndCmd(tagOApiRelatePoint^ obj)
		{
			if (m_ehSysCoorCenter)
			{
				m_ehSysCoorCenter(obj);
			}
		}
		void WndCmd(tagOApiSysCoorInfoCli^ obj)
		{
			if (m_ehSysCoorInfo)
			{
				m_ehSysCoorInfo(obj);
			}
		}
		void WndCmd(tagOApiObjTree^ obj)
		{
			if (m_ehGetObjTree)
			{
				m_ehGetObjTree(obj);
			}
		}
		void WndCmd(double obj, eEventHanderType eType)
		{
			if (m_ehGetProgRate)
			{
				m_ehGetProgRate(obj,eType);
			}
		}
		void WndCmd(cli::array<tagOApiObjectSrhResCli^>^ obj)
		{
			if (m_ehGetObjSrhRes)
			{
				m_ehGetObjSrhRes(obj);
			}
		}
		void WndCmd(tagOmapGetMapCli^ obj)
		{
			if (m_ehGetOmapMapdata)
			{
				m_ehGetOmapMapdata(obj);
			}
		}
		void WndCmd(tagOmapGetMapFileCli^ obj)
		{
			if (m_ehGetMapFile)
			{
				m_ehGetMapFile(obj);
			}
		}
		void WndCmd(tagOmapReqContourCli^ obj)
		{
			if (m_ehGetContour)
			{
				m_ehGetContour(obj);
			}
		}
		void WndCmd(cli::array<tagOApiObjIdItem^>^ pObjIds)
		{
			if (m_ehSetObjTree)
			{
				m_ehSetObjTree(pObjIds);
			}
		}
		void WndCmd(int iBtnStatus)
		{
			if (m_ehSetOmapBtn)
			{
				m_ehSetOmapBtn(iBtnStatus);
			}
		}
		void WndCmd(tagWebSocketConf^ obj)
		{
			if (m_ehGetWebSocketConf)
			{
				m_ehGetWebSocketConf(obj);
			}
		}
		void WndCmd(cli::array<tagCustomMap^>^ obj)
		{
			if (m_ehGetCusMap)
			{
				m_ehGetCusMap(obj);
			}
		}
		void WndCmd(tagPrj^ obj)
		{
			if (m_ehGetSysCoordProj)
			{
				m_ehGetSysCoordProj(obj);
			}
		}
		void WndCmd(tagPluginVer^ obj)
		{
			if (m_ehGetPluginVer)
			{
				m_ehGetPluginVer(obj);
			}
		}
		void WndCmd(tagOmapWndRect^ obj)
		{
			if (m_ehGetOmapWndRect)
			{
				m_ehGetOmapWndRect(obj);
			}
		}
		void WndCmd(tagMapShapeDetail^ obj)
		{
			if (m_ehGetMapShapeDetail)
			{
				m_ehGetMapShapeDetail(obj);
			}
		}
		void WndCmd(tagMapTrackDetail^ obj)
		{
			if (m_ehGetMapTrackDetail)
			{
				m_ehGetMapTrackDetail(obj);
			}
		}
		void WndCmd(cli::array<tagCusMainBtnCli^>^ obj,int nCmdId)
		{
			if (m_ehGetMainBtn)
			{
				m_ehGetMainBtn(obj,nCmdId);
			}
		}
		void WndCmd(cli::array<tagCusFavMenuCli^>^ obj, int nCmdId)
		{
			if (m_ehGetFavMenu)
			{
				m_ehGetFavMenu(obj, nCmdId);
			}
		}
		void WndCmd(int iObjEventCmd,int nCmdId)
		{
			if (m_ehGetObjEvent)
			{
				m_ehGetObjEvent(iObjEventCmd,nCmdId);
			}
		}
		void WndCmd(tagCusMainMenuCli^ obj)
		{
			if (m_ehGetCusMainMenuClickEvent)
			{
				m_ehGetCusMainMenuClickEvent(obj);
			}
		}
		void WndCmd(tagMapObjEvent^ obj)
		{
			if (m_ehGetObjEventTirgger)
			{
				m_ehGetObjEventTirgger(obj);
			}
		}
		void WndCmd(int id, eEventHanderType eType)
		{
			if (m_ehGetCloseWnd)
			{
				m_ehGetCloseWnd(id, eType);
			}
		}
		void SetEventHander(GetLatlngEventHander^ eh)
		{
			m_ehGetLatlng = eh;
		}
		void SetEventHander(GetGeoDecodeEventHander^ eh)
		{
			m_ehGeoDecode = eh;
		}
		void SetEventHander(GetLatlngByTimeEventHander^ eh)
		{
			m_ehGetLatlngByTime = eh;
		}
		void SetEventHander(GetObjListEventHander^ eh)
		{
			m_ehGetObjList = eh;
		}
		void SetEventHander(GetObjSignEventHander^ eh)
		{
			m_ehGetSign = eh;
		}
		void SetEventHander(GetObjTrackEventHander^ eh)
		{
			m_ehGetTrack = eh;
		}
		void SetEventHander(GetObjShapeEventHander^ eh)
		{
			m_ehGetShape = eh;
		}
		void SetEventHander(GetObjDirectionsEventHander^ eh)
		{
			m_ehGetDir = eh;
		}
		void SetEventHander(GetObjGroupEventHander^ eh)
		{
			m_ehGetGroup = eh;
		}
		void SetEventHander(GetObjSignArrayEventHander^ eh)
		{
			m_ehGetSigns = eh;
		}
		void SetEventHander(GetObjTrackArrayEventHander^ eh)
		{
			m_ehGetTracks = eh;
		}
		void SetEventHander(GetObjShapeArrayEventHander^ eh)
		{
			m_ehGetShapes = eh;
		}
		void SetEventHander(GetObjDirectionsArrayEventHander^ eh)
		{
			m_ehGetDirs = eh;
		}
		void SetEventHander(GetObjGroupArrayEventHander^ eh)
		{
			m_ehGetGroups = eh;
		}
		void SetEventHander(NullParamEventHander^ eh)
		{
			m_ehNullParam = eh;
		}
		void SetEventHander(GetObjChangeEventHander^ eh)
		{
			m_ehObjChange = eh;
		}
		void SetEventHander(GetMapInfoEventHander^ eh)
		{
			m_ehMapInfo = eh;
		}
		void SetEventHander(GetGooglePixelInfoEventHander^ eh)
		{
			m_ehPixelInfo = eh;
		}
		void SetEventHander(GetSysCoorCenterEventHander^ eh)
		{
			m_ehSysCoorCenter = eh;
		}
		void SetEventHander(GetSysCoorInfoEventHander^ eh)
		{
			m_ehSysCoorInfo = eh;
		}
		void SetEventHander(GetObjTreeStructEventHander^ eh)
		{
			m_ehGetObjTree = eh;
		}
		void SetEventHander(GetProgressRateEventHander^ eh)
		{
			m_ehGetProgRate = eh;
		}
		void CancelEventHander(GetProgressRateEventHander^ eh)
		{
			m_ehGetProgRate = nullptr;
		}
		void SetEventHander(GetObjSrhResEventHander^ eh)
		{
			m_ehGetObjSrhRes = eh;
		}
		void SetEventHander(GetOmapMapDataEventHander^ eh)
		{
			m_ehGetOmapMapdata = eh;
		}
		void SetEventHander(GetOmapMapFileEventHander^ eh)
		{
			m_ehGetMapFile = eh;
		}
		void SetEventHander(GetContourEventHander^ eh)
		{
			m_ehGetContour = eh;
		}
		void SetEventHander(SetObjTreeEventHander^ eh)
		{
			m_ehSetObjTree = eh;
		}
		void SetEventHander(SetOmapBtnEventHander^ eh)
		{
			m_ehSetOmapBtn = eh;
		}
		void SetEventHander(GetWebSocketConfEventHander^ eh)
		{
			m_ehGetWebSocketConf = eh;
		}
		void SetEventHander(GetCustomMapEventHander^ eh)
		{
			m_ehGetCusMap = eh;
		}
		void SetEventHander(GetSysCoordProjEventHander^ eh)
		{
			m_ehGetSysCoordProj = eh;
		}
		void SetEventHander(GetOmapPluginVerEventHander^ eh)
		{
			m_ehGetPluginVer = eh;
		}
		void SetEventHander(GetOmapWndRectEventHander^ eh)
		{
			m_ehGetOmapWndRect = eh;
		}
		void SetEventHander(GetMapShapeDetailEventHander^ eh)
		{
			m_ehGetMapShapeDetail = eh;
		}
		void SetEventHander(GetMapTrackDetailEventHander^ eh)
		{
			m_ehGetMapTrackDetail = eh;
		}
		void SetEventHander(GetCusMainBtnEventHander^ eh)
		{
			m_ehGetMainBtn = eh;
		}
		void SetEventHander(GetCusFavMenuEventHander^ eh)
		{
			m_ehGetFavMenu = eh;
		}
		void SetEventHander(GetObjEventHander^ eh)
		{
			m_ehGetObjEvent = eh;
		}
		void SetEventHander(GetCusMainMenuClickEventHander^ eh)
		{
			m_ehGetCusMainMenuClickEvent = eh;
		}
		void SetEventHander(GetObjEventTirggerEventHander^ eh)
		{
			m_ehGetObjEventTirgger = eh;
		}
		void SetEventHander(GetObjCloseWndEventHander^ eh)
		{
			m_ehGetCloseWnd = eh;
		}
	
#pragma endregion
#pragma region DataConversion
		String^ cast_strUtf8_to_String(char *strUtf8);
		tagOApiObjGroupV3 *CLI2Dll(tagOApiObjGroup^ pGroup);
		tagOApiMapSignV3 *CLI2Dll(tagOApiMapSign^ pSign);
		tagOApiMapTrackV3 *CLI2Dll(tagOApiMapTrack^ pTrack);
		tagOApiMapShapeV3 *CLI2Dll(tagOApiMapShape^ pShape);
		tagOApiMapDirectionsV3 *CLI2Dll(tagOApiMapDirections^ pDir);
		tagOApiObjectSrhReq *CLI2Dll(tagOApiObjectSrhReqCli^ pSrh);
		tagOApiRelatePointV1 *CLI2Dll(tagOApiRelatePoint^ pPoint);
		tagOApiRelatePointV1 *CLI2Dll(cli::array<tagOApiRelatePoint^>^ pPoints);
		tagOPhotoMapPic *CLI2Dll(cli::array<tagOphotoMapPicCli^>^ pPics);
		DWORD* CLI2Dll(cli::array<UINT>^ pidList);
		tagOmapGetMapFile* CLI2Dll(cli::array<tagOmapGetMapFileCli^>^ pMapFiles);
		tagOmapReqContour* CLI2Dll(tagOmapReqContourCli^ pCon);
		tagOApiPrj* CLI2Dll(tagPrj^ prj);
		tagOApiCusShowWnd* CLI2Dll(tagCusShowWnd^ CusShowWnd);
		tagOApiMapObjShowWnd* CLI2Dll(tagMapObjShowWnd^ MapObjShowWnd);
		tagOApiObjGroup^ Dll2CLI(tagOApiObjGroupV2 *pGroupDll);
		tagOApiMapSign^ Dll2CLI(tagOApiMapSignV2 *pSignDll);
		tagOApiMapTrack^ Dll2CLI(tagOApiMapTrackV2 *pTrackDll);
		tagOApiMapShape^ Dll2CLI(tagOApiMapShapeV2 *pShapeDll);
		tagOApiMapDirections^ Dll2CLI(tagOApiMapDirectionsV2 *pDirDll);
		tagOApiObjectSrhReqCli^ Dll2CLI(tagOApiObjectSrhReq *pSrhDll);
		tagOApiRelatePoint^ Dll2CLI(tagOApiRelatePointV1* pOrp);
		tagOmapLatlngCli^ Dll2CLI(tagOmapLatlng* poll);
		cli::array<tagOphotoMapPicCli^>^ Dll2CLI(tagOPhotoMapPic* pOmp, int nOmp);
		cli::array<tagOApiItemList^>^ Dll2CLI(tagOApiItemListV1* pOlvs, int nOlv);
		tagOApiObjChageHdrCli^ Dll2CLI(tagOApiObjChageHdr* pOch);
		tagWinMapInfoCli^ Dll2CLI(tagWinMapInfo* pWmi);
		cli::array<tagOApiPixelInfoCli^>^ Dll2CLI(tagOApiPixelInfo *pOpi, int nOpi);
		tagOApiSysCoorInfoCli^ Dll2CLI(tagOApiSysCoorInfo* pSci);
		tagOApiShapeFillCadPatItemCli^ Dll2CLI(tagOApiShapeFillCadPatItem* pPatItem);
		tagOmapGetMapFileCli^ Dll2CLI(tagOmapGetMapFile* pMapFile);
		tagOmapReqContourCli^ Dll2CLI(tagOmapReqContour* pCon);
		tagWebSocketConf^ Dll2CLI(tagOApiWebSocketConf* pWsc);
		cli::array<tagCustomMap^>^ Dll2CLI(tagOApiCustomMap* pCms, int nCm);
		tagPrj^ Dll2CLI(tagOApiPrj *pPrj); 
		tagPluginVer^ Dll2CLI(tagOApiPluginVer *pPluginVer); 
		tagOmapWndRect^ Dll2CLI(tagOApiOmapWndRect *pOmapWndRect);
		tagMapShapeDetail^ Dll2CLI(tagOApiMapShapeDetail *pMapShapeDetail);
		tagMapTrackDetail^ Dll2CLI(tagOApiMapTrackDetail *pMapTrackDetail);
		cli::array<tagCusMainBtnCli^>^ Dll2CLI(tagCusMainBtn* pCbs, int nCb);
		cli::array<tagCusFavMenuCli^>^ Dll2CLI(tagCusFavMenu* pCfs, int nData);
		tagCusMainMenuCli^ Dll2CLI(tagCusMainMenu* pCusMainMenu);
		tagMapObjEvent^ Dll2CLI(tagOApiMapObjEvent* pMapObjEvent);
		

#pragma endregion
#pragma region OmapApiFuc
		INT64  SetOmapObject(DWORD idObj, tagOApiObjGroup^ pGroup,DWORD idParent , int iPosition);
		INT64  SetOmapObject(DWORD idObj, tagOApiMapSign^ pSign, DWORD idParent, int iPosition);
		INT64  SetOmapObject(DWORD idObj, tagOApiMapTrack^ pTrack, DWORD idParent, int iPosition);
		INT64  SetOmapObject(DWORD idObj, tagOApiMapShape^ pShape, DWORD idParent, int iPosition);
		INT64  SetOmapObject(DWORD idObj, tagOApiMapDirections^ pDir,  DWORD idParent, int iPosition);
		int SetSysCoorPoint(int iCoorType, cli::array<tagOApiRelatePoint^>^ pPoints);
		int SetSysCoorPoint(int iCoorType, tagOApiRelatePoint^ pPoint);
		int SetOmapLevelAndLocationExt(int iMapID, int iMapLevel, double x_lng, double y_lat, BYTE bActive, BYTE bReal, int iTimeoutMs);
		void SetOmapTmpSign(double lat, double lng, bool bGcj02);
		int SetOmapButton(int iAdd, String^ strTip, int iTimeoutMs);
		int SetPicSignList(cli::array<tagOphotoMapPicCli^>^ pOmps);
		int SetOmapSelectIdList(cli::array<UINT>^ pidList);
		//һ
		int SetOmapSelObjectTree(tagOApiObjTree^ pObjTree, DWORD idParent);
		//ϵӶ
		void PrePareSetObjTree(DWORD idParent);
		bool AddObjTree(tagOApiObjTree^ pObjTree, DWORD idParent);
		int CommitObjTree();
		int GetOmapSelObjectTree(BYTE bLlType, BYTE bBatchGetObjTree);
		void SetObjTree(tagOApiObjDataItem *pData,int nItem);
		int GetOmapObjectList(DWORD idParent);
		int GetOmapObject(DWORD idObj, BYTE bLlType);
		int GetOmapStatusInfo();
		int GetOmapMapData(double x_lng1, double y_lat1, double x_lng2, double y_lat2, INT64 iMaxPixel, int iMaxLevel);
		int GetOmapMapFile(cli::array<tagOmapGetMapFileCli^>^ pReqs);
		int GetOmapContour(tagOmapReqContourCli^ pReq);
		int SetCmdCusWnd(tagCusShowWnd^ CusShowWnd);
		int QueryCusShowWnd(int idWnd);
		int DelCusShowWnd(int idWnd);
		int SetObjShowWnd(tagMapObjShowWnd^ MapObjShowWnd);
		int SetCusMainBtn(int size);
		int DelCusMainBtn(cli::array<int>^ids, int nCnt);
		int QueryCusMainBtn(cli::array<int>^ids, int nCnt);
		int SetCusFavMenu(int size);
		int DelCusFavMenu(cli::array<int>^ids, int nCnt);
		int QueryCusFavMenu(cli::array<int>^ids, int nCnt);
		int GetOmapSelectList(int iFlag);
		int SetObjEvent(int iObjEventCmd);
		int SetCusMainMenu();
		int DelCusMainMenu();
		int GetWebSocketConf();
		int GetCusMapCfgList();
		int SetSysCoordProj(tagPrj^ prj);
		int GetSysCoordProj();
		int ReGetOmapContour();
		int GetLatlng();
		int GetLatlngByTime(cli::array<tagOphotoMapPicCli^>^ pOmps);
		void GetSysCoorInfo();
		void GetSysCoorCenter();
		void GetCoorPixelInfo(double lng_x, double lat_y);
		void GetWinMapInfo(BYTE bRealLL);
		int FollowWinMapInfo(int iFollowMs);
		int FollowObjChange(int iAppID);
		int MoveOmapObject(int idParent, int nIndexInParent, cli::array<int>^ idList, int nId);
		
		void DecodeContour(tagOmapReqContour* pReq);
		bool DecodeOmapSingleObjBuf(tagOApiObjectOptHdr *pOoh, int nBuf);
		bool DecodeOmapObjBuf(tagOApiObjectOptHdr *pOptHdr);
		bool DecodeOmapObjBuf2TreeStruct(tagOApiObjectOptHdr *pOptHdr);
		void DecodeMapFile(tagOmapGetMapFile* pMapFile);
		void DecodeMapData(tagOmapGetMap * pMapData, BYTE *pData, int nData);
		void DecodeObjSrhRes(tagOApiObjectSrhRes* pSrhRes, int nRes);

		void GeoDecodeLatlng(double lat, double lng, bool bGcj02);
		void CleanOmapTmpObject();
		int DelOmapObject(cli::array<DWORD>^ pidList, int nId, bool bNoGroup, bool bForceDel);
		int SrhOmapObject(tagOApiObjectSrhReqCli^ pSrhReq);
		int ReqVip5Demo(bool bSend);
		int CheckInterfaceVer(int iType, int iVer, bool bSendReq);
		int GetOmapPluginVer();
		int GetOmapWndRect();
		int GetMapShapeDetail(DWORD idObj);
		int GetMapTrackDetail(DWORD idObj);
		
		void PrintMsgBox(char* strMsg, char* strTitle);
		void ReleaseRes();
#pragma region Pattern
#pragma region װӿ
		tagOApiShapeFillCadPatItemCli^ GetPatItemDef(DWORD dwFillPattern);
		String^ GetPatItem(DWORD dwFillPattern);
		DWORD GetPatItemId(String^ StrPatName);
#pragma endregion
#pragma region ԭӿ
		int SendGetShapeFillPatList();
		bool DeocdeShapeFillPatList(void *pBuf, int nBuf);
		void FreeShapeFillPatList(bool bFreeMe);
#pragma endregion
#pragma endregion
#pragma endregion
	};

}
